#property copyright ""
#property link      ""
#include <stderror.mqh> 

// version 0.2  2011/09/2

//+------------------------------------------------------------------+
//| Global Variables / Includes                                      |
//+------------------------------------------------------------------+
datetime   CurrTime = 0;
datetime   PrevTime = 0;
  string        Sym = "";
     int  TimeFrame = 0;
     int      Shift = 1;
     int  SymDigits = 5;
  double  SymPoints = 0.0001;
  
     int MA1ArraySelected = 0;
     int MA2ArraySelected = 0;
     int MA1MethodSelected = 0;
     int MA2MethodSelected = 0;
     
     int ProfitTarget = 0;
     int StopLoss = 0;
int progtp = 0;
int progsl = 0;

int mode = 0;
int m1count = 0, m2count = 0, m1tpcount = 0, m1slcount = 0,
  m2tpcount = 0, m2slcount = 0;
double m1ary[], m2ary[], m1tpary[], m1slary[], m2tpary[], m2slary[];
int m1len, m2len, m1tplen, m1sllen, m2tplen, m2sllen;
double Lots = 0.0;
int tradecount = 0;
int lasttradecount = 0;

//+------------------------------------------------------------------+
//| Expert User Inputs                                               |
//+------------------------------------------------------------------+
// message to emit at start of program run
extern string msg1="visit my site for manuals and .set files";
extern string msg2="http://plorks-mmm.blogspot.com/";
extern string msg3="http://plorksmmm.com/";
extern string msg4="dont be a turtle, read the manual";
extern string msg5="";
extern string msg6="make notes about your .set files here";

extern bool   UseCompletedBars = true;

// Create any user input for the indicators you will use here
// For example:
extern string MA1Array   = "Close";
extern string MA2Array   = "Close";
extern int    MA1Periods = 1;
extern int    MA2Periods = 7;
extern string MA1Method  = "Simple";
extern string MA2Method  = "Simple";

//extern double         Lots = 0.01;
extern    int  MagicNumber =  666;
extern int mode1tp = 90;
extern int mode1sl = 30;
extern int mode2tp = 20;
extern int mode2sl = 60;
extern    int     Slippage =    3;

// Plork mods
extern string Mode1Prog="0.1;0.2;0.3;0.4";
extern string Mode2Prog="0.01;0.02;0.03;0.04";
extern bool SingleMode = false;
extern bool UseMode1 = true;
extern double MaxSpread = 100.0;
extern int StartHour1 = 0;
extern int StopHour1 = 0;
extern int StartHour2 = 0;
extern int StopHour2 = 0;
extern int StartHour3 = 0;
extern int StopHour3 = 0;
extern string Mode1TPProg="50;60;70";
extern string Mode1SLProg="20;30;40";
extern string Mode2TPProg="10;20;30";
extern string Mode2SLProg="100;120;140";
extern bool UseMode1TPProg = true;
extern bool UseMode1SLProg = true;
extern bool UseMode2TPProg = true;
extern bool UseMode2SLProg = true;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
         Sym = Symbol();
   TimeFrame = Period();   
   SymPoints = MarketInfo( Sym, MODE_POINT  );
   SymDigits = MarketInfo( Sym, MODE_DIGITS );
   //---
        if( SymPoints == 0.001   ) { SymPoints = 0.01;   SymDigits = 3; }
   else if( SymPoints == 0.00001 ) { SymPoints = 0.0001; SymDigits = 5; }
   
     //------------------ CLOSE -------------------------
       if(MA1Array == "C")      {MA1ArraySelected = PRICE_CLOSE;}
  else if(MA1Array == "CLOSE")  {MA1ArraySelected = PRICE_CLOSE;}
  else if(MA1Array == "Close")  {MA1ArraySelected = PRICE_CLOSE;}
  else if(MA1Array == "c")      {MA1ArraySelected = PRICE_CLOSE;}
  else if(MA1Array == "close")  {MA1ArraySelected = PRICE_CLOSE;}
  //------------------ LOW -------------------------
  else if(MA1Array == "L")    {MA1ArraySelected = PRICE_LOW;}
  else if(MA1Array == "LOW")  {MA1ArraySelected = PRICE_LOW;}
  else if(MA1Array == "Low")  {MA1ArraySelected = PRICE_LOW;}
  else if(MA1Array == "l")    {MA1ArraySelected = PRICE_LOW;}
  else if(MA1Array == "low")  {MA1ArraySelected = PRICE_LOW;}
  //------------------ HIGH -------------------------
  else if(MA1Array == "H")     {MA1ArraySelected = PRICE_HIGH;}
  else if(MA1Array == "HIGH")  {MA1ArraySelected = PRICE_HIGH;}
  else if(MA1Array == "High")  {MA1ArraySelected = PRICE_HIGH;}
  else if(MA1Array == "h")     {MA1ArraySelected = PRICE_HIGH;}
  else if(MA1Array == "high")  {MA1ArraySelected = PRICE_HIGH;}
  //------------------ OPEN-------------------------
  else if(MA1Array == "O")     {MA1ArraySelected = PRICE_OPEN;}
  else if(MA1Array == "OPEN")  {MA1ArraySelected = PRICE_OPEN;}
  else if(MA1Array == "Open")  {MA1ArraySelected = PRICE_OPEN;}
  else if(MA1Array == "o")     {MA1ArraySelected = PRICE_OPEN;}
  else if(MA1Array == "open")  {MA1ArraySelected = PRICE_OPEN;}
  //------------------ Typical -------------------------
  else if(MA1Array == "TYPICAL") {MA1ArraySelected = PRICE_TYPICAL;}
  else if(MA1Array == "Typical") {MA1ArraySelected = PRICE_TYPICAL;}
  else if(MA1Array == "typical") {MA1ArraySelected = PRICE_TYPICAL;}
  else if(MA1Array == "T")       {MA1ArraySelected = PRICE_TYPICAL;}
  else if(MA1Array == "t")       {MA1ArraySelected = PRICE_TYPICAL;}
  //------------------ MEDIAN -------------------------------
  else if(MA1Array == "MEDIAN") {MA1ArraySelected = PRICE_MEDIAN;}
  else if(MA1Array == "Median") {MA1ArraySelected = PRICE_MEDIAN;}
  else if(MA1Array == "median") {MA1ArraySelected = PRICE_MEDIAN;}
  else if(MA1Array == "M")      {MA1ArraySelected = PRICE_MEDIAN;}
  else if(MA1Array == "m")      {MA1ArraySelected = PRICE_MEDIAN;}
  //------------------ DEFAULT -------------------------------
  else                       
  {
   Alert("Please select a valid array in open, high, Low, Close, Typical, Median" );
   return(-1);
  }

     //------------------ CLOSE -------------------------
       if(MA2Array == "C")      {MA2ArraySelected = PRICE_CLOSE;}
  else if(MA2Array == "CLOSE")  {MA2ArraySelected = PRICE_CLOSE;}
  else if(MA2Array == "Close")  {MA2ArraySelected = PRICE_CLOSE;}
  else if(MA2Array == "c")      {MA2ArraySelected = PRICE_CLOSE;}
  else if(MA2Array == "close")  {MA2ArraySelected = PRICE_CLOSE;}
  //------------------ LOW -------------------------
  else if(MA2Array == "L")    {MA2ArraySelected = PRICE_LOW;}
  else if(MA2Array == "LOW")  {MA2ArraySelected = PRICE_LOW;}
  else if(MA2Array == "Low")  {MA2ArraySelected = PRICE_LOW;}
  else if(MA2Array == "l")    {MA2ArraySelected = PRICE_LOW;}
  else if(MA2Array == "low")  {MA2ArraySelected = PRICE_LOW;}
  //------------------ HIGH -------------------------
  else if(MA2Array == "H")     {MA2ArraySelected = PRICE_HIGH;}
  else if(MA2Array == "HIGH")  {MA2ArraySelected = PRICE_HIGH;}
  else if(MA2Array == "High")  {MA2ArraySelected = PRICE_HIGH;}
  else if(MA2Array == "h")     {MA2ArraySelected = PRICE_HIGH;}
  else if(MA2Array == "high")  {MA2ArraySelected = PRICE_HIGH;}
  //------------------ OPEN-------------------------
  else if(MA2Array == "O")     {MA2ArraySelected = PRICE_OPEN;}
  else if(MA2Array == "OPEN")  {MA2ArraySelected = PRICE_OPEN;}
  else if(MA2Array == "Open")  {MA2ArraySelected = PRICE_OPEN;}
  else if(MA2Array == "o")     {MA2ArraySelected = PRICE_OPEN;}
  else if(MA2Array == "open")  {MA2ArraySelected = PRICE_OPEN;}
  //------------------ Typical -------------------------
  else if(MA2Array == "TYPICAL") {MA2ArraySelected = PRICE_TYPICAL;}
  else if(MA2Array == "Typical") {MA2ArraySelected = PRICE_TYPICAL;}
  else if(MA2Array == "typical") {MA2ArraySelected = PRICE_TYPICAL;}
  else if(MA2Array == "T")       {MA2ArraySelected = PRICE_TYPICAL;}
  else if(MA2Array == "t")       {MA2ArraySelected = PRICE_TYPICAL;}
  //------------------ MEDIAN -------------------------------
  else if(MA2Array == "MEDIAN") {MA2ArraySelected = PRICE_MEDIAN;}
  else if(MA2Array == "Median") {MA2ArraySelected = PRICE_MEDIAN;}
  else if(MA2Array == "median") {MA2ArraySelected = PRICE_MEDIAN;}
  else if(MA2Array == "M")      {MA2ArraySelected = PRICE_MEDIAN;}
  else if(MA2Array == "m")      {MA2ArraySelected = PRICE_MEDIAN;}
  //------------------ DEFAULT -------------------------------
  else                       
  {
   Alert("Please select a valid array in open, high, Low, Close, Typical, Median" );
   return(-1);
  }
  //------------------ CLOSE -------------------------
       if(MA1Method == "Simple")  {MA1MethodSelected = MODE_SMA; }
  else if(MA1Method == "SIMPLE")  {MA1MethodSelected = MODE_SMA; }
  else if(MA1Method == "S")       {MA1MethodSelected = MODE_SMA; }
  else if(MA1Method == "s")       {MA1MethodSelected = MODE_SMA; }
  else if(MA1Method == "simple")  {MA1MethodSelected = MODE_SMA; }
  //------------------ LOW -------------------------
  else if(MA1Method == "Exponential") { MA1MethodSelected = MODE_EMA;}
  else if(MA1Method == "EXPONENTIAL") { MA1MethodSelected = MODE_EMA;}
  else if(MA1Method == "E")           { MA1MethodSelected = MODE_EMA;}
  else if(MA1Method == "e")           { MA1MethodSelected = MODE_EMA;}
  else if(MA1Method == "exponential") { MA1MethodSelected = MODE_EMA;}
  //------------------ DEFAULT -------------------------------
  else                       
  {
   Alert("Please select a valid Method: Simple or Exponential" );
   return(-1);
  }
  //------------------ CLOSE -------------------------
       if(MA2Method == "Simple")  {MA2MethodSelected = MODE_SMA; }
  else if(MA2Method == "SIMPLE")  {MA2MethodSelected = MODE_SMA; }
  else if(MA2Method == "S")       {MA2MethodSelected = MODE_SMA; }
  else if(MA2Method == "s")       {MA2MethodSelected = MODE_SMA; }
  else if(MA2Method == "simple")  {MA2MethodSelected = MODE_SMA; }
  //------------------ LOW -------------------------
  else if(MA2Method == "Exponential") { MA2MethodSelected = MODE_EMA;}
  else if(MA2Method == "EXPONENTIAL") { MA2MethodSelected = MODE_EMA;}
  else if(MA2Method == "E")           { MA2MethodSelected = MODE_EMA;}
  else if(MA2Method == "e")           { MA2MethodSelected = MODE_EMA;}
  else if(MA2Method == "exponential") { MA2MethodSelected = MODE_EMA;}
  //------------------ DEFAULT -------------------------------
  else                       
  {
   Alert("Please select a valid Method: Simple or Exponential" );
   return(-1);
  }
  
   //----

// Copied from powersm
   int i,j,k;
   string ls;

   while (true) {
   	j=StringFind(Mode1Prog,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode1Prog,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m1ary,k);
   		m1ary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode1Prog,i);
   		k++;
   		ArrayResize(m1ary,k);
   		m1ary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m1len=ArraySize(m1ary);

   i = 0; j = 0; k = 0;
   while (true) {
   	j=StringFind(Mode2Prog,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode2Prog,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m2ary,k);
   		m2ary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode2Prog,i);
   		k++;
   		ArrayResize(m2ary,k);
   		m2ary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m2len=ArraySize(m2ary);

   i = 0; j = 0; k = 0;
   while (true) {
   	j=StringFind(Mode1TPProg,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode1TPProg,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m1tpary,k);
   		m1tpary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode1TPProg,i);
   		k++;
   		ArrayResize(m1tpary,k);
   		m1tpary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m1tplen=ArraySize(m1tpary);

   i = 0; j = 0; k = 0;
   while (true) {
   	j=StringFind(Mode1SLProg,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode1SLProg,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m1slary,k);
   		m1slary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode1SLProg,i);
   		k++;
   		ArrayResize(m1slary,k);
   		m1slary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m1sllen=ArraySize(m1slary);

   i = 0; j = 0; k = 0;
   while (true) {
   	j=StringFind(Mode2TPProg,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode2TPProg,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m2tpary,k);
   		m2tpary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode2TPProg,i);
   		k++;
   		ArrayResize(m2tpary,k);
   		m2tpary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m2tplen=ArraySize(m2tpary);

   i = 0; j = 0; k = 0;
   while (true) {
   	j=StringFind(Mode2SLProg,";",i);
   	if (j>0) {
   		ls=StringSubstr(Mode2SLProg,i,j-i);
   		i=j+1;
   		k++;
   		ArrayResize(m2slary,k);
   		m2slary[k-1]=StrToDouble(ls);
   	} else {
   		ls=StringSubstr(Mode2SLProg,i);
   		k++;
   		ArrayResize(m2slary,k);
   		m2slary[k-1]=StrToDouble(ls);
   		break;
   	}
   }
   m2sllen=ArraySize(m2slary);

   if(UseMode1 == true) {
     mode = 1;
   } else {
     mode = 2;
   }

   // print initial message
   Print(msg1);
   Print(msg2);
   Print(msg3);
   Print(msg4);
   Print(msg5);
   Print(msg6);

   return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() { return(0); }

//+------------------------------------------------------------------+
//| Expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{    
     int RealTime = 0;
     if( UseCompletedBars )
     {
      CurrTime = iTime(Sym, TimeFrame, 1 );
      if( CurrTime == PrevTime )
      {
         return(0);
      } 
      //---- Update Vars
      PrevTime = CurrTime;
      RealTime = 1;
     }
      
      //---- Need to chek for a new Signal?
      if( CountAll( Sym, MagicNumber) == 0)
      {
         //---- Indicator 1 Values
         double Indicator1CurrentValue  = iMA(NULL,0,MA1Periods,0,MA1MethodSelected, MA1ArraySelected,0+RealTime);
         double Indicator1PreviousValue = iMA(NULL,0,MA1Periods,0,MA1MethodSelected, MA1ArraySelected,1+RealTime);
         //---- Indicator 2 Values
         double Indicator2CurrentValue  = iMA(NULL,0,MA2Periods,0,MA2MethodSelected, MA2ArraySelected,0+RealTime);
         double Indicator2PreviousValue = iMA(NULL,0,MA2Periods,0,MA2MethodSelected, MA2ArraySelected,1+RealTime);
         
	 int h = Hour();
	 bool tradetimeok = false;
	 bool tradelimitactive = false;
	 if(StartHour1 < StopHour1) {
	   tradelimitactive = true;
	   if(h >= StartHour1 && h <= StopHour1) {
	     tradetimeok = true;
	   }
	 }
	 if(StartHour2 < StopHour2) {
	   tradelimitactive = true;
	   if(h >= StartHour2 && h <= StopHour2) {
	     tradetimeok = true;
	   }
	 }
	 if(StartHour3 < StopHour3) {
	   tradelimitactive = true;
	   if(h >= StartHour3 && h <= StopHour3) {
	     tradetimeok = true;
	   }
	 }
	 if(tradelimitactive == false) {
	   tradetimeok = true;
	 }

         //---- Moving Average Cross System
	 if(tradetimeok == true) {
              if( Indicator1CurrentValue > Indicator2CurrentValue && 
		  Indicator1PreviousValue <= Indicator2PreviousValue ) { 
		if(CheckSpread() == true) {
		  CalcProgression();
		  Print("Going long mode " + mode + " lotsize: " + 
			Lots + ", TP/SL " + ProfitTarget + "/" + StopLoss);
		  if(EnterLong(Sym, Lots, "") > 0) {
		    tradecount++;
		  }
		}
	      } else 
		if( Indicator1CurrentValue < Indicator2CurrentValue && 
		    Indicator1PreviousValue >= Indicator2PreviousValue ) { 
		  if(CheckSpread() == true) {
		    CalcProgression();
		    Print("Going short mode " + mode + " lotsize: " + Lots 
			  + ", TP/SL " + ProfitTarget + "/" + StopLoss);
		    if(EnterShrt(Sym, Lots, "") > 0) {
		      tradecount++;
		    }
		  }
		}
	 }
      //----
   
   //----
      }
   return(0); 
}

//+------------------------------------------------------------------+
//| Expert Custom Functions                                          |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| CountAll()                                                       |
//+------------------------------------------------------------------+
int CountAll( string Symbole, int Magic )
{
    //---- 
    int count = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if ( OrderMagicNumber() != Magic   ) continue;
        if (      OrderSymbol() != Symbole ) continue;
        
             if ( OrderType() == OP_BUY  ) { count++; }
        else if ( OrderType() == OP_SELL ) { count++; }
    }
    //----
    return(count);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Stop Long                                              |
//+------------------------------------------------------------------+
double StopLong(double price,double stop,double point,double SymDgts )
{
 if(stop==0) { return(0); }
 else        { return(NormalizeDouble( price-(stop*point),SymDgts)); }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Stop Short                                             |
//+------------------------------------------------------------------+
double StopShrt(double price,double stop,double point,double SymDgts )
{
 if(stop==0) { return(0); }
 else        { return(NormalizeDouble( price+(stop*point),SymDgts)); }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeLong(double price,double take,double point,double SymDgts )
{
 if(take==0) {  return(0);}
 else        {  return(NormalizeDouble( price+(take*point),SymDgts));}
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeShrt(double price,double take,double point,double SymDgts )
{
 if(take==0) {  return(0);}
 else        {  return(NormalizeDouble( price-(take*point),SymDgts));}
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Place Long Order                                                 |
//+------------------------------------------------------------------+
int EnterLong( string FinalSymbol, double FinalLots, string EA_Comment )
{
   int Ticket = -1; int err = 0; bool OrderLoop = False; int TryCount = 0;
                     
   while( !OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 10 ); }
                           
      RefreshRates();
      double SymAsk = NormalizeDouble( MarketInfo( FinalSymbol, MODE_ASK ), SymDigits );    
      double SymBid = NormalizeDouble( MarketInfo( FinalSymbol, MODE_BID ), SymDigits );
                               
      Ticket = OrderSend( FinalSymbol, OP_BUY, FinalLots, SymAsk, 0, 0.0, 0.0, EA_Comment, MagicNumber, 0, CLR_NONE ); 
                           
      int Err=GetLastError();
      
      switch (Err) 
      {
           //---- Success
           case               ERR_NO_ERROR: OrderLoop = true; 
                                            if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                            { OrderModify( Ticket, OrderOpenPrice(), StopLong(SymBid,StopLoss, SymPoints,SymDigits), TakeLong(SymAsk,ProfitTarget,SymPoints,SymDigits), 0, CLR_NONE ); }
                                            break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = true; Print( "Invalid Stops"    ); break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = true; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = true; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = true; Print( "Unknown Error - " + Err ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = true; }
   }
   //----               
   return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Place Shrt Order                                                 |
//+------------------------------------------------------------------+
int EnterShrt( string FinalSymbol, double FinalLots, string EA_Comment )
{
   int Ticket = -1; int err = 0; bool OrderLoop = False; int TryCount = 0;
                     
   while( !OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 10 ); }
                           
      RefreshRates();
      double SymAsk = NormalizeDouble( MarketInfo( FinalSymbol, MODE_ASK ), SymDigits );    
      double SymBid = NormalizeDouble( MarketInfo( FinalSymbol, MODE_BID ), SymDigits );
                               
      Ticket = OrderSend( FinalSymbol, OP_SELL, FinalLots, SymBid, 0,  0.0,0.0, EA_Comment, MagicNumber, 0, CLR_NONE ); 
                           
      int Err=GetLastError();
      
      switch (Err) 
      {
           //---- Success
                 case               ERR_NO_ERROR: OrderLoop = true;
                                                  if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                                  { OrderModify( Ticket, OrderOpenPrice(), StopShrt(SymAsk,StopLoss, SymPoints,SymDigits), TakeShrt(SymBid,ProfitTarget, SymPoints,SymDigits), 0, CLR_NONE ); }
                                                  break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = true; Print( "Invalid Stops"    ); break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = true; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = true; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = true; Print( "Unknown Error - " + Err ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = true; }
   }
   //----               
   return(Ticket);
}
//+------------------------------------------------------------------+


bool LastTradeWin() 
{
   for(int i=OrdersHistoryTotal()-1;i>=0;i--) 
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
      {
         if (OrderProfit()>0) 
          return(true); 
         else 
          return(false);
      }
   }
   return(false);
}

int CalcProgression() {
  // Determine lot size for this trade
  // mode1 - increase thru progression until win
  // mode2 - increase thru progression until loss
  if(tradecount == lasttradecount) {
    if(mode == 1) {
      Lots = m1ary[m1count];
      if(UseMode1TPProg == true) {
	ProfitTarget = m1tpary[m1tpcount];
      } else {
	ProfitTarget = mode1tp;
      }
      if(UseMode1SLProg == true) {
	StopLoss = m1slary[m1slcount];
      } else {
	StopLoss = mode1sl;
      }	
    } else {
      Lots = m2ary[m2count];
      if(UseMode2TPProg == true) {
	ProfitTarget = m2tpary[m2tpcount];
      } else {
	ProfitTarget = mode2tp;
      }
      if(UseMode2SLProg == true) {
	StopLoss = m2slary[m2slcount];
      } else {
	StopLoss = mode2sl;
      }
    }
    return(0);
  }
  lasttradecount = tradecount;
  bool ltstat = LastTradeWin();
  if(SingleMode == false) {
    if(mode == 1) {
      if(ltstat == true) {
	Print("Last trade won, switching to mode 2");
	mode = 2;
	m1count = 0;
	m2count = 0;
	m1tpcount = 0;
	m1slcount = 0;
	m2tpcount = 0;
	m2slcount = 0;
      } else {
	Print("Last trade lost, increasing lot progression");
	m1count++;
	if(m1count >= m1len) {
	  Print("Reached end of progression, switching to mode 2");
	  mode = 2;
	  m1count = 0;
	  m2count = 0;
	  m1tpcount = 0;
	  m1slcount = 0;
	  m2tpcount = 0;
	  m2slcount = 0;
	}
	m1tpcount++;
	if(m1tpcount >= m1tplen) {
	  Print("Reached end of mode 1 tp, resetting");
	  m1tpcount = 0;
	}
	m1slcount++;
	if(m1slcount >= m1sllen) {
	  Print("Reached end of mode 1 sl, resetting");
	  m1slcount = 0;
	}
      }
    } else {
      if(ltstat == false) {
	Print("Last trade lost, switching to mode 1");
	mode = 1;
	m1count = 0;
	m2count = 0;
	m1tpcount = 0;
	m1slcount = 0;
	m2tpcount = 0;
	m2slcount = 0;
      } else {
	Print("Last trade won, increasing lot progression");
	m2count++;
	if(m2count >= m2len) {
	  Print("Reached end of progression, switching to mode 1");
	  mode = 1;
	  m1count = 0;
	  m2count = 0;
	  m1tpcount = 0;
	  m1slcount = 0;
	  m2tpcount = 0;
	  m2slcount = 0;
	}
	m2tpcount++;
	if(m2tpcount >= m2tplen) {
	  Print("Reached end of mode 2 tp, resetting");
	  m2tpcount = 0;
	}
	m2slcount++;
	if(m2slcount >= m2sllen) {
	  Print("Reached end of mode 2 sl, resetting");
	  m2slcount = 0;
	}
      }
    }
  } else if(UseMode1 == true) {
    mode = 1;
    if(ltstat == true) {
      Print("Last trade won, resetting progression");
      m1count = 0;
      m1tpcount = 0;
      m1slcount = 0;
    } else {
      Print("Last trade lost, increasing progression");
      m1count++;
      if(m1count >= m1len) {
	Print("Reached end of progression, resetting");
	m1count = 0;
	m1tpcount = 0;
	m1slcount = 0;
      }
      m1tpcount++;
      if(m1tpcount >= m1tplen) {
	Print("Reached end of mode 1 tp, resetting");
	m1tpcount = 0;
      }
      m1slcount++;
      if(m1slcount >= m1sllen) {
	Print("Reached end of mode 1 sl, resetting");
	m1slcount = 0;
      }
    }
  } else {
    mode = 2;
    if(ltstat == false) {
      Print("Last trade lost, resetting progression");
      m2count = 0;
      m2tpcount = 0;
      m2slcount = 0;
    } else {
      Print("Last trade won, increasing progression");
      m2count++;
      if(m2count >= m2len) {
	Print("Reached end of progression, resetting");
	m2count = 0;
	m2tpcount = 0;
	m2slcount = 0;
      }
      m2tpcount++;
      if(m2tpcount >= m2tplen) {
	Print("Reached end of mode 2 tp, resetting");
	m2tpcount = 0;
      }
      m2slcount++;
      if(m2slcount >= m2sllen) {
	Print("Reached end of mode 2 sl, resetting");
	m2slcount = 0;
      }
    }
  }

  if(mode == 1) {
    Lots = m1ary[m1count];
    if(UseMode1TPProg == true) {
      ProfitTarget = m1tpary[m1tpcount];
    } else {
      ProfitTarget = mode1tp;
    }
    if(UseMode1SLProg == true) {
      StopLoss = m1slary[m1slcount];
    } else {
      StopLoss = mode1sl;
    }	
  } else {
    Lots = m2ary[m2count];
    if(UseMode2TPProg == true) {
      ProfitTarget = m2tpary[m2tpcount];
    } else {
      ProfitTarget = mode2tp;
    }
    if(UseMode2SLProg == true) {
      StopLoss = m2slary[m2slcount];
    } else {
      StopLoss = mode2sl;
    }
  }

  return(0);
}


bool CheckSpread() {
  double spread = MarketInfo(Symbol(), MODE_SPREAD);
  if(spread <= MaxSpread) {
    Print("Spread OK (" + spread + ")");
    return(true);
  } else {
    Print("Spread limit exceeded! (" + spread + " > " + MaxSpread + ")");
    return(false);
  }
}